unit utf8xmlpars;

interface
uses
    JclUnicode,LibXmlParser,
  Windows, Messages, SysUtils, Classes, Controls, Dialogs, StdCtrls;

type
  //UTF-8WideStringւ̕ϊXMLParser̒`
  // http://www.fabrice.co.jp/docs/ ŉĂ̂ŎQƂ̂
  TUtf8ToWideXMLParser = class(TXMLParser)
  private
   FCodeConversionEnabled: Boolean;
  public
   property CodeConversionEnabled: Boolean read FCodeConversionEnabled write FCodeConversionEnabled;
   function TranslateEncoding(const Source: string): string; override;
   constructor Create;
  end;

implementation

{------------------------------------------------------------------------------}
{ constructor                                                                  }
{------------------------------------------------------------------------------}
constructor TUtf8ToWideXMLParser.Create;
begin
   inherited Create;
     FCodeConversionEnabled := false;
end;

{------------------------------------------------------------------------------}
{ TranslateEncoding UTF-8 to WideString                                        }
{------------------------------------------------------------------------------}
function TUtf8ToWideXMLParser.TranslateEncoding(const Source: string): string;
begin
    Result := Source;
    if (FCodeConversionEnabled) and (UpperCase(CurEncoding)='UTF-8') then
       Result := UTF8ToWideString(Source)
end;

end.
